/* This demo is meant to demonstrate the use of a free
   object in a form.

   Written by Mark Overmars
   Date 29 Apr 1991
*/

#include <gl/gl.h>
#include "forms.h"

int on = 1, col = 32, dcol = 1;

int handle_it(FL_OBJECT *obj, int event, float mx, float my, char key)
/* The call back routine */
{
  switch (event)
  {
    case FL_DRAW:
        fl_color(col);
        rectf(obj->x,obj->y,obj->x+obj->w,obj->y+obj->h);
        return 0;
    case FL_RELEASE:
	on = !on;
        return 0;
    case FL_STEP:
 	if (on)
	{ 
	  if (col == 55) dcol = -1;
	  if (col == 32) dcol = 1;
	  col += dcol;
          fl_redraw_object(obj);
	}
        return 0;
  }
  return 0;
}

main()
{
  FL_FORM *form;
  FL_OBJECT *obj, *but;

  fl_init();
  form = fl_bgn_form(FL_UP_BOX,400.0,400.0);
  obj = fl_add_free(FL_CONTINUOUS_FREE,40.0,80.0,320.0,280.0,"",handle_it);
  but = fl_add_button(FL_NORMAL_BUTTON,320.0,20.0,40.0,30.0,"Exit");
  fl_end_form();

  fl_show_form(form,FL_PLACE_CENTER,FALSE,NULL);
  while (obj != but)
     obj = fl_do_forms();
  fl_hide_form(form);
}
