
/* Demo showing activating and deactivating objects
*/

#include <stdlib.h>
#include <stdio.h>
#include "forms.h"

FL_FORM *form;

FL_OBJECT
        *button1,
        *button2,
        *button3,
        *button4,
        *group,
        *firstbut;

void exit_cb(FL_OBJECT *obj, long arg)
  { exit(0); }

void setit(FL_OBJECT *obj, int val)
{
  if (val)
  {
    fl_set_object_lcol(obj,0);
    fl_activate_object(obj);
  }
  else
  {
    fl_set_object_lcol(obj,8);
    fl_deactivate_object(obj);
  }
}

void doit(int b1, int b2, int b3, int b4)
{
  setit(button1,b1);
  setit(button2,b2);
  setit(button3,b3);
  setit(button4,b4);
}

void set_active(FL_OBJECT *obj, long arg)
{
  switch (arg)
  {
    case 0: doit(1,1,1,1); break;
    case 1: doit(0,0,0,0); break;
    case 2: doit(0,1,0,1); break;
    case 3: doit(1,0,1,0); break;
  }
}

void create_form()
{
  FL_OBJECT *obj;
  form = fl_bgn_form(FL_NO_BOX,420.0,230.0);
  obj = fl_add_box(FL_UP_BOX,0.0,0.0,420.0,230.0,"");
    fl_set_object_color(obj,12,47);
  button1 = obj = fl_add_button(FL_NORMAL_BUTTON,20.0,170.0,150.0,40.0,"Button 1");
    fl_set_object_lsize(obj,FL_LARGE_FONT);
  button2 = obj = fl_add_button(FL_NORMAL_BUTTON,20.0,120.0,150.0,40.0,"Button 2");
    fl_set_object_lsize(obj,FL_LARGE_FONT);
  button3 = obj = fl_add_button(FL_NORMAL_BUTTON,20.0,70.0,150.0,40.0,"Button 3");
    fl_set_object_lsize(obj,FL_LARGE_FONT);
  button4 = obj = fl_add_button(FL_NORMAL_BUTTON,20.0,20.0,150.0,40.0,"Button 4");
    fl_set_object_lsize(obj,FL_LARGE_FONT);
  group = fl_bgn_group();
  firstbut = obj = fl_add_lightbutton(FL_RADIO_BUTTON,260.0,180.0,140.0,30.0,"All active");
    fl_set_call_back(obj,set_active,0);
  obj = fl_add_lightbutton(FL_RADIO_BUTTON,260.0,150.0,140.0,30.0,"Non active");
    fl_set_call_back(obj,set_active,1);
  obj = fl_add_lightbutton(FL_RADIO_BUTTON,260.0,120.0,140.0,30.0,"Even active");
    fl_set_call_back(obj,set_active,2);
  obj = fl_add_lightbutton(FL_RADIO_BUTTON,260.0,90.0,140.0,30.0,"Odd active");
    fl_set_call_back(obj,set_active,3);
  fl_end_group();
  obj = fl_add_button(FL_NORMAL_BUTTON,270.0,20.0,130.0,30.0,"Quit");
    fl_set_call_back(obj,exit_cb,0);
  fl_end_form();
}

main()
{
  create_form();
  fl_set_button(firstbut,1);
  fl_show_form(form,FL_PLACE_CENTER,FALSE,NULL);
  while (1) fl_do_forms();
}
